<template>
  <div class="rf">
    <div class="rf__title">
      {{ $t('forms.respondents.title') }}
    </div>
    <div class="rf__conditions">
      <div
        v-for="(condition, index) in conditions"
        :key="index"
        class="rf__condition"
      >
        <div class="condition">
          <div
            v-if="index > 0"
            class="condition__and"
          >
            {{ $t('forms.respondents.and') }}
          </div>
          <div class="condition__title">
            {{ $t('forms.respondents.condition', {n: index + 1}) }}
          </div>
          <div class="condition__field">
            <FormSelect
              v-model="condition.field"
              :options="availableFieldsList"
              :placeholder="$t('forms.respondents.fieldPlaceholder')"
              @input="(value) => setConditionField(index, value)"
            />
          </div>
          <div
            v-if="condition.field"
            class="condition__values"
          >
            <div
              v-for="(value, valueIndex) in condition.value"
              :key="valueIndex"
              class="condition__value"
            >
              <div class="condition__value-label">
                <div
                  v-if="valueIndex > 0"
                  class="condition__or"
                >
                  {{ $t('forms.respondents.or') }}
                </div>
                <span>
                  {{ $t('forms.respondents.typeLabel', {
                    type: $t(
                      ['range'].indexOf(availableFields[condition.field].type) > -1
                        ? `forms.respondents.types.${availableFields[condition.field].type}`
                        : `forms.respondents.fields.${condition.field}.short`
                    ),
                    n: valueIndex + 1
                  }) }}
                </span>
              </div>
              <div class="condition__value-field">
                <component
                  :is="`Form${ucFirst(availableFields[condition.field].type)}`"
                  v-model="condition.value[valueIndex]"
                  v-bind="getFieldOptions(condition)"
                />
              </div>
            </div>
          </div>
          <div class="condition__controls">
            <div
              v-if="condition.value.length"
              class="condition__add"
            >
              <Button
                state="success"
                @click="addValue(index)"
              >
                <Icon
                  slot="before"
                  type="plus"
                  size="lg"
                />
                {{ $t('forms.respondents.addType', {
                  type: $t(
                    ['range'].indexOf(availableFields[condition.field].type) > -1
                      ? `forms.respondents.types.${availableFields[condition.field].type}`
                      : `forms.respondents.fields.${condition.field}.short`
                  )
                }) }}
              </Button>
            </div>
            <div
              class="condition__remove"
            >
              <Button
                state="danger"
                @click="removeCondition(index)"
              >
                <Icon
                  slot="before"
                  type="trash"
                  size="lg"
                />
                {{ $t('forms.respondents.removeCondition') }}
              </Button>
            </div>
          </div>
        </div>
      </div>
    </div>
    <button
      class="rf__add"
      @click="addCondition"
    >
      <span class="rf__add-icon">
        <Icon
          type="plusThin"
          size="xl"
        />
      </span>
      <span
        class="rf__add-label"
        v-html="String($t('forms.respondents.addCondition')).replace(/\n/g, '<br/>')"
      />
    </button>
    <div class="rf__footer">
      <div class="rf__test">
        <Button
          state="successOutline"
          @click="test"
        >
          {{ $t('forms.respondents.test') }}
        </Button>
      </div>
      <div class="rf__next">
        <Button
          state="successFilled"
          @click="next"
        >
          {{ $t('forms.respondents.next') }}
          <Icon
            slot="after"
            type="arrowRight"
            size="xl"
          />
        </Button>
      </div>
    </div>
  </div>
</template>

<script>
import Icon from '../Icon';
import FormSelect from '../form/select/FormSelect';
import { stringHelperMixin } from '../../helpers/stringHelper';
import FormRange from '../form/range/FormRange';
import Button from '../button/Button';

export default {
  name: 'RespondentsForm',
  components: {
    Button,
    FormSelect,
    Icon,
    FormRange,
  },
  mixins: [stringHelperMixin],
  data() {
    return {
      conditions: [],
      availableFields: {
        age: {
          type: 'range',
        },
        cardType: {
          type: 'select',
          options: ['silver', 'gold', 'platinum'],
        },
        cardStatus: {
          type: 'select',
          options: ['disabled', 'enabled'],
        },
      },
    };
  },
  computed: {
    availableFieldsList() {
      return Object.entries(this.availableFields).map(([key]) => ({
        key,
        text: this.$t(`forms.respondents.fields.${key}.label`),
      }));
    },
    model() {
      return this.conditions.filter(({ field }) => !!field).map(({ field, value }) => ({
        field,
        type: this.availableFields[field].type,
        value,
      }));
    },
  },
  methods: {
    getFieldOptions(condition) {
      const field = this.availableFields[condition.field];
      const { type } = field;

      if (type === 'select') {
        return {
          options: field.options.map((key) => ({
            key,
            text: this.$t(`forms.respondents.fields.${condition.field}.values.${key}`),
          })),
        };
      }

      return {

      };
    },
    addCondition() {
      this.conditions = [...this.conditions, {
        field: null,
        value: [],
      }];
    },
    removeCondition(index) {
      // I know it's side-effect. Doesn't matter in that case
      this.conditions.splice(index, 1);
    },
    getValueByType(type) {
      return {
        range: [null, null],
        select: null,
      }[type];
    },
    addValue(index) {
      this.$set(this.conditions[index], 'value', [
        ...this.conditions[index].value,
        this.getValueByType(this.availableFields[this.conditions[index].field].type),
      ]);
    },
    setConditionField(index, field) {
      this.$set(this.conditions, index, {
        ...this.conditions[index],
        field,
        value: field ? [
          this.getValueByType(this.availableFields[field].type),
        ] : [],
      });
    },
    test() {
      alert('test');
    },
    next() {
      this.$emit('filled', this.model);
    },
  },
};
</script>

<style lang="scss">
  @import "../../assets/variables";
  .rf {
    &__title {
      font-size: 18px;
      font-weight: bold;
      color: darken($color-gray, 20%);
    }

    &__conditions {
      margin-top: 14px;
    }

    &__condition {
      margin: 0 -40px;
      padding: 34px 40px 50px;
      border-bottom: solid 1px darken($color-gray, 5%);

      position: relative;

      &:nth-child(3n+1) {
        background: $color-snow;

        .condition__title {
          color: darken($color-snow, 60%);
        }

        .condition__or, .condition__and {
          background: darken($color-snow, 10%);
        }
      }

      &:nth-child(3n+2) {
        background: $color-ghostWhite;

        .condition__title {
          color: darken($color-ghostWhite, 60%);
        }

        .condition__or, .condition__and {
          background: darken($color-ghostWhite, 10%);
        }
      }

      &:nth-child(3n+3) {
        background: $color-mintCream;

        .condition__title {
          color: darken($color-mintCream, 60%);
        }

        .condition__or, .condition__and {
          background: darken($color-mintCream, 10%);
        }
      }
    }

    &__add {
      border-radius: 6px;
      box-shadow: 0 0 0 3px $color-gray;
      margin: 40px 0;
      padding: 24px;

      display: grid;

      width: 100%;

      color: $color-green;

      cursor: pointer;

      &-icon {
        display: flex;
        justify-content: center;
      }

      &-label {
        font-size: 16px;
        display: block;
        margin-top: 20px;
      }

      &:hover,
      &:focus {
        box-shadow: 0 0 0 3px darken($color-gray, 20%);
      }
    }

    &__footer {
      margin: 0 -40px -40px;
      padding: 40px;
      background: $color-ghostWhite;

      display: flex;
      align-items: center;
      justify-content: space-between;

      border-radius: 0 0 10px 10px;
    }
  }

  .condition {
    display: grid;
    align-items: center;

    grid-template-columns: auto 1fr;
    grid-row-gap: 40px;
    grid-template-areas:
      'title field'
      'values values'
      '. controls';

    &__title {
      grid-area: title;

      font-size: 18px;
      font-weight: bold;
      min-width: 240px;
    }

    &__field {
      grid-area: field;
    }

    &__values {
      grid-area: values;

      display: grid;
      grid-gap: 20px;
    }

    &__value {
      display: grid;
      align-items: center;
      grid-template-columns: auto 1fr;

      &-label {
        min-width: 240px;
        font-size: 15px;

        display: flex;
        align-items: center;
      }
    }

    &__or {
      font-size: 15px;
      margin-right: 20px;
      padding: 10px 12px;
      border-radius: 6px;
      display: block;
      text-transform: lowercase;
    }

    &__and {
      font-size: 15px;
      margin-right: 20px;
      padding: 10px 20px;
      border-radius: 6px;
      display: block;
      position: absolute;
      left: 40px;
      top: 0;
      transform: translateY(-50%);
    }

    &__controls {
      grid-area: controls;

      display: flex;
      align-items: center;
      justify-content: space-between;
    }

    &__add {
      margin-right: 30px;
    }

    &__remove {
      margin-left: auto;
    }
  }
</style>
